'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generated by CoffeeScript 2.0.2
(function () {
  var InputComponent,
      InteractiveComponent,
      PropTypes,
      React,
      SKIP_PARSING,
      arrayToHash,
      getRegexValidation,
      omit,
      parseValidations,
      validations,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  React = require('react');

  PropTypes = require('prop-types');

  omit = require('lodash/omit');

  validations = require('nebenan-helpers/lib/validations');

  var _require = require('nebenan-helpers/lib/utils/data');

  arrayToHash = _require.arrayToHash;


  InteractiveComponent = require('./interactive_component');

  SKIP_PARSING = arrayToHash(['isRequired', 'isRegex']);

  parseValidations = function parseValidations(validationsString) {
    var args, i, len, name, ref, results, validation;
    if (!validationsString) {
      return [];
    }
    if (typeof validationsString !== 'string') {
      throw new Error('validation must be a string');
    }
    ref = validationsString.split(';');
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      validation = ref[i];

      var _validation$split = validation.split(':');

      var _validation$split2 = (0, _slicedToArray3.default)(_validation$split, 2);

      name = _validation$split2[0];
      args = _validation$split2[1];

      if (SKIP_PARSING[name] || !validations[name]) {
        continue;
      }
      args = (args != null ? args.split(',') : void 0) || [];
      results.push(function () {
        var _validations;

        for (var _len = arguments.length, ownArgs = Array(_len), _key = 0; _key < _len; _key++) {
          ownArgs[_key] = arguments[_key];
        }

        return (_validations = validations)[name].apply(_validations, ownArgs.concat((0, _toConsumableArray3.default)(args.map(JSON.parse))));
      });
    }
    return results;
  };

  getRegexValidation = function getRegexValidation(pattern) {
    var regex;
    regex = new RegExp('^' + pattern + '$');
    return function (value) {
      return validations.isRegex(value, regex);
    };
  };

  InputComponent = function () {
    var InputComponent = function (_InteractiveComponent) {
      (0, _inherits3.default)(InputComponent, _InteractiveComponent);

      function InputComponent(props) {
        (0, _classCallCheck3.default)(this, InputComponent);

        var _this = (0, _possibleConstructorReturn3.default)(this, (InputComponent.__proto__ || Object.getPrototypeOf(InputComponent)).call(this, props));

        _this.validate = _this.validate.bind(_this);
        _this.clearValidationError = _this.clearValidationError.bind(_this);
        _this.setValidationError = _this.setValidationError.bind(_this);
        _this.setError = _this.setError.bind(_this);
        _this.state = _this.getDefaultState(props);
        return _this;
      }

      (0, _createClass3.default)(InputComponent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          var _getValidations;

          (0, _get3.default)(InputComponent.prototype.__proto__ || Object.getPrototypeOf(InputComponent.prototype), 'componentDidMount', this).call(this);
          if (this.isConnected()) {
            this.context.form.addInput(this);
          }
          return _getValidations = this.getValidations(this.props), this.syncValidations = _getValidations.syncValidations, this.asyncValidation = _getValidations.asyncValidation, _getValidations;
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (this.isConnected()) {
            this.context.form.removeInput(this);
          }
          return (0, _get3.default)(InputComponent.prototype.__proto__ || Object.getPrototypeOf(InputComponent.prototype), 'componentWillUnmount', this).call(this);
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var _getValidations2;

          return _getValidations2 = this.getValidations(nextProps), this.syncValidations = _getValidations2.syncValidations, this.asyncValidation = _getValidations2.asyncValidation, _getValidations2;
        }
      }, {
        key: 'validate',
        value: function validate() {
          var promise;
          boundMethodCheck(this, InputComponent);
          promise = this.getValidation(this.getValue());
          promise.then(this.clearValidationError).catch(this.setValidationError);
          return promise;
        }
      }, {
        key: 'isConnected',
        value: function isConnected() {
          return this.context.form && this.getName();
        }
      }, {
        key: 'isValid',
        value: function isValid() {
          return this.state.isValid;
        }
      }, {
        key: 'isPristine',
        value: function isPristine() {
          return this.state.isPristine;
        }
      }, {
        key: 'isErrorActive',
        value: function isErrorActive() {
          return !this.isValid() && this.getError();
        }
      }, {
        key: 'isRequired',
        value: function isRequired() {
          return this.syncValidations.indexOf(validations.isRequired) !== -1;
        }
      }, {
        key: 'getInput',
        value: function getInput() {
          return this.refs.input || this.els.input;
        }
      }, {
        key: 'getValidations',
        value: function getValidations(props) {
          var asyncValidation, syncValidations;
          syncValidations = [];
          asyncValidation = null;
          if (typeof props.validate === 'function') {
            asyncValidation = props.validate;
          } else {
            syncValidations = parseValidations(props.validate);
          }
          if (props.required) {
            syncValidations.push(validations.isRequired);
          }
          if (props.pattern) {
            syncValidations.push(getRegexValidation(props.pattern));
          }
          return { syncValidations: syncValidations, asyncValidation: asyncValidation };
        }
      }, {
        key: 'getValidation',
        value: function getValidation(value) {
          var func, hasValue, i, len, ref;
          hasValue = validations.isRequired(value);
          // Prevent validating empty non-required fields, reject early if input required and empty
          if (this.isRequired()) {
            if (!hasValue) {
              return Promise.reject();
            }
          } else {
            if (!hasValue) {
              return Promise.resolve();
            }
          }
          ref = this.syncValidations;
          // prevent async validations triggering if sync validations invalid
          for (i = 0, len = ref.length; i < len; i++) {
            func = ref[i];
            if (!func(value)) {
              return Promise.reject();
            }
          }
          if (this.asyncValidation) {
            return this.asyncValidation(value);
          }
          return Promise.resolve();
        }
      }, {
        key: 'getDefaultState',
        value: function getDefaultState(props) {
          return {
            isPristine: true,
            isValid: true,
            error: null,
            value: props.defaultValue
          };
        }
      }, {
        key: 'getValidationError',
        value: function getValidationError() {
          return this.props.error || true;
        }
      }, {
        key: 'clearValidationError',
        value: function clearValidationError() {
          boundMethodCheck(this, InputComponent);
          return this.setError(null);
        }
      }, {
        key: 'setValidationError',
        value: function setValidationError() {
          boundMethodCheck(this, InputComponent);
          return this.setError(this.getValidationError());
        }
      }, {
        key: 'getError',
        value: function getError() {
          return this.state.error;
        }
      }, {
        key: 'getName',
        value: function getName() {
          return this.props.name;
        }
      }, {
        key: 'getValue',
        value: function getValue() {
          return this.state.value;
        }
      }, {
        key: 'reset',
        value: function reset(done) {
          var _this2 = this;

          var updater;
          if (!this.isComponentMounted) {
            return;
          }
          updater = function updater(state, props) {
            return _this2.getDefaultState(props);
          };
          return this.setState(updater, done);
        }
      }, {
        key: 'setValue',
        value: function setValue(value, done) {
          var _this3 = this;

          var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

          var complete, error, isPristine, isValid;
          if (!this.isComponentMounted) {
            return;
          }
          isPristine = false;
          isValid = true;
          error = null;
          complete = function complete() {
            var base, base1;
            if (!options.silent) {
              if (typeof (base = _this3.props).onUpdate === "function") {
                base.onUpdate(_this3.getValue());
              }
            }
            if (Boolean(_this3.getError())) {
              if (!options.silent) {
                if (typeof (base1 = _this3.props).onError === "function") {
                  base1.onError(_this3.getError());
                }
              }
              if (_this3.isConnected()) {
                _this3.context.form.updateValidity();
              }
            }
            return typeof done === "function" ? done() : void 0;
          };
          return this.setState({ isPristine: isPristine, isValid: isValid, error: error, value: value }, complete);
        }
      }, {
        key: 'setError',
        value: function setError(error, done) {
          var _this4 = this;

          var complete, isPristine, isValid;
          boundMethodCheck(this, InputComponent);
          if (!this.isComponentMounted) {
            return;
          }
          isPristine = false;
          isValid = !error;
          complete = function complete() {
            var base;
            if (typeof (base = _this4.props).onError === "function") {
              base.onError(_this4.getError());
            }
            if (_this4.isConnected()) {
              _this4.context.form.updateValidity();
            }
            return typeof done === "function" ? done() : void 0;
          };
          return this.setState({ isPristine: isPristine, isValid: isValid, error: error }, complete);
        }
      }, {
        key: 'setPristine',
        value: function setPristine(done) {
          var _this5 = this;

          var updater;
          if (!this.isComponentMounted) {
            return;
          }
          updater = function updater(state, props) {
            return omit(_this5.getDefaultState(props), 'value');
          };
          return this.setState(updater, done);
        }
      }, {
        key: 'actionChange',
        value: function actionChange(action) {
          var _this6 = this;

          return function (event) {
            _this6.setValue(event.target.value);
            return typeof action === "function" ? action(event) : void 0;
          };
        }
      }, {
        key: 'actionClearError',
        value: function actionClearError(action) {
          var _this7 = this;

          return function (event) {
            _this7.setError(null);
            return typeof action === "function" ? action(event) : void 0;
          };
        }
      }, {
        key: 'actionValidate',
        value: function actionValidate(action) {
          var _this8 = this;

          return function (event) {
            _this8.validate();
            return typeof action === "function" ? action(event) : void 0;
          };
        }
      }]);
      return InputComponent;
    }(InteractiveComponent);

    ;

    InputComponent.contextTypes = {
      locale: PropTypes.object,
      form: PropTypes.object
    };

    return InputComponent;
  }();

  module.exports = InputComponent;
}).call(undefined);