import PropTypes from 'prop-types';
import { checkPropsPresence } from './utils';
import BaseComponent from './base_component';


class MapComponent extends BaseComponent {
  constructor(props) {
    super(props);

    checkPropsPresence(this,
      'create',
      'update',
      'destroy',
    );
  }

  componentDidMount() { this.create(this.props, this.context); }
  componentWillReceiveProps(nextProps, nextContext) { this.update(nextProps, nextContext); }
  componentWillUnmount() { this.destroy(); }

  // Mandatory
  // create(props, context) {}
  // update(nextProps, nextContext) {}
  // destroy() {}
}

MapComponent.contextTypes = {
  map: PropTypes.object,
};

export default MapComponent;
